#include "rep-decoder.h"

RepDecoder::RepDecoder(int hdrlen) 
  : PacketHandler(hdrlen),
    inw_(0), inh_(0),
    callback_(0),
    delay_flag_(0)
{
}

RepDecoder::~RepDecoder() 
{
  pktbuf *pb;
  pb = delay_q_.get_next();
  while (pb != 0) {
    pb->release();
    pb = delay_q_.get_next();
  }

  if (callback_ != 0) {
    free(callback_);
  }
};

void
RepDecoder::recv(pktbuf *pb)
{
  if (delay_flag_) {
    delay_q_.insert(pb);
    return;
  }
  post_delay_recv(pb);
}

int 
RepDecoder::command(int argc, const char*const* argv) {
  if (argc == 3) {
    if (strcmp(argv[1], "set_frame_buffer") == 0) {
      VidRep *fb;
      fb = (VidRep *)TclObject::lookup(argv[2]);
      set_frame_buffer(fb);
      return TCL_OK;
    }
   if (strcmp(argv[1], "set_callback") == 0) {
      if (callback_ != 0) {
	free(callback_);
	callback_ = 0;
      }
      if (strlen(argv[2]) > 0) {
	callback_ = (char *) malloc(strlen(argv[2])+1);
	strcpy(callback_, argv[2]);
      }
      return TCL_OK;
    }
  } else if (argc == 2) {
    if (strcmp(argv[1], "delay_on") == 0) {
      delay_flag_ = 1;
      return TCL_OK;
    }
    if (strcmp(argv[1], "delay_off") == 0) {
      pktbuf *pb;
      delay_flag_ = 0;
      pb = delay_q_.get_next();
      while (pb != 0) {
	post_delay_recv(pb);
	pb = delay_q_.get_next();
      }
      return TCL_OK;
    }
  }
  return (PacketHandler::command(argc, argv));
}

double RepDecoder::gettimeofday()
{
  timeval tv;
  ::gettimeofday(&tv, 0);
  return (1e6 * double(tv.tv_sec) + double(tv.tv_usec));
}
