#ifndef mash_rtcp_session_h
#define mash_rtcp_session_h

#include "net.h"
#include "rtp.h"

class RTCP_Session : public TclObject, public SessionHandler {
public:
  RTCP_Session();
  virtual ~RTCP_Session();
  virtual int command(int argc, const char*const* argv);
  virtual void recv(CtrlHandler *);
  virtual void recv(DataHandler *);
  virtual void announce(CtrlHandler *);
protected:
  CtrlHandler ch_[NLAYER];
  SourceManager *sm_;
  u_char *pktbuf_;

  void parse_sr(rtcphdr* rh, int flags, u_char* ep,
		Source* ps, u_int32_t addr, int layer);
  void parse_rr(rtcphdr* rh, int flags, u_char* ep,
		Source* ps, u_int32_t addr, int layer);
  void parse_rr_records(u_int32_t ssrc, rtcp_rr* r, int cnt,
			const u_char* ep, u_int32_t addr);
  int sdesbody(u_int32_t* p, u_char* ep, Source* ps,
	       u_int32_t addr, u_int32_t ssrc, int layer);
  void parse_sdes(rtcphdr* rh, int flags, u_char* ep, Source* ps,
		  u_int32_t addr, u_int32_t ssrc, int layer);
  void parse_bye(rtcphdr* rh, int flags, u_char* ep, Source* ps);
  virtual void parse_app(rtcphdr* rh, int flags, u_char* ep, Source* ps);
};


  
  
#endif
