/*
 * Copyright (c) 1998 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *       This product includes software developed by the Computer Systems
 *       Engineering Group at Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * ------------
 *
 * Filename: tgmb-defs.h
 *   -- Created on Sun Jan  4 1998
 *   -- Author: Yatin Chawathe <yatin@cs.berkeley.edu>
 *
 * Description:
 *
 *
 *  @(#) $Header: /usr/src/mash/repository/mash/mash-1/tgmb/client/tgmb-defs.h,v 1.3 1998/09/08 20:03:12 yatin Exp $
 */

#ifndef MASH_TGMB_DEFS_H
#define MASH_TGMB_DEFS_H



#define TGMB_VERSION              0x01050201

#define TGMB_CREATOR		  'TGmb'
#define TGMB_APPTYPE              'TGmb'

#define TGMB_DBTYPE_TMP           'STOR'
#define TGMB_DBTYPE_SESSION       'SESS'
#define TGMB_DBTYPE_SESSIDX       'SIDX'

#define TGMB_DBNAME_TMP		  "TopGunMBTmpStorage"
#define TGMB_DBNAME_CACHE_INDEX	  "TopGunMBCacheIndex"

#define TGMB_MAXUSERNAME          64
#define TGMB_MAXHOSTNAME          128
#define TGMB_MAXADDRSPEC          32
#define TGMB_MAXPORTSPEC          10

#define TGMB_DEFAULT_RmxSvr       "208.1.90.52"
#define TGMB_DEFAULT_RmxPort      60000
#define TGMB_DEFAULT_UserName     ""
#define TGMB_DEFAULT_DontSuspend  0
#define TGMB_DEFAULT_Session      "224.4.4.4/6666"

#define MAX_SESSION_URL           32
#define MAX_SESSION_NAME          (MAX_SESSION_URL - 7)


#define APP                       TGMB_Application::Instance()
#define SESSION                   TGMB_Application::Instance()->Session()


/*#define MAXINDEX		  0xffff

#define MbEOP			  (MAXINDEX-1)
#define MbNotPresent		  (MAXINDEX-2)
#define MbInUse			  (MAXINDEX-3)*/


struct SrcId {
	DWord ss_uid;
	DWord ss_addr;
};

struct PageId {
	struct SrcId sid;
	DWord uid;
};

typedef DWord TGMB_ObjectId;

#endif /* #ifdef MASH_TGMB_DEFS_H */ 
